Codeforces Round #338 (Div. 2) C. Running Track dp C. Running Track

题目连接:

http://www.codeforces.com/contest/615/problem/C

Description

A boy named Ayrat lives on planet AMI-1511. Each inhabitant of this planet has a talent. Specifically, Ayrat loves running, moreover, just running is not enough for him. He is dreaming of making running a real art.

First, he wants to construct the running track with coating t. On planet AMI-1511 the coating of the track is the sequence of colored blocks, where each block is denoted as the small English letter. Therefore, every coating can be treated as a string.

Unfortunately, blocks aren't freely sold to non-business customers, but Ayrat found an infinite number of coatings s. Also, he has scissors and glue. Ayrat is going to buy some coatings s, then cut out from each of them exactly one continuous piece (substring) and glue it to the end of his track coating. Moreover, he may choose to flip this block before glueing it. Ayrat want's to know the minimum number of coating s he needs to buy in order to get the coating t for his running track. Of course, he also want's to know some way to achieve the answer.

Input

First line of the input contains the string s — the coating that is present in the shop. Second line contains the string t — the coating Ayrat wants to obtain. Both strings are non-empty, consist of only small English letters and their length doesn't exceed 2100.

Output

The first line should contain the minimum needed number of coatings n or -1 if it's impossible to create the desired coating.

If the answer is not -1, then the following n lines should contain two integers xi and yi — numbers of ending blocks in the corresponding piece. If xi ≤ yi then this piece is used in the regular order, and if xi > yi piece is used in the reversed order. Print the pieces in the order they should be glued to get the string t.

Sample Input

abc

cbaabc

Sample Output

2

3 1

1 3

Hint

题意

给你一个字符串s,然后给你字符串t,让你用s中的子串来构成t。

并输出构造方案。

s可以旋转

题解:

我们可以直接跑dp,预处理dp1[i][j],表示匹配到s串的i位置,t串的j位置时候,最多可以往前跳dp1[i][j]个字符。

其实这个就是最长公共前缀的dp。

跑完之后,我们就可以跑第二个dp了,dp[i]表示以t的i位置结尾所需要的最少次数。

很显然dp[i] = max(dp[i],dp[i-dp1[j][i]]+1);

然后记录一下过程,倒着跑一下DP,把路径输出就好了。

代码

#include<bits/stdc++.h>
using namespace std;
#define maxn 3000
long long dp1[maxn][maxn];
long long dp2[maxn][maxn];
char a[maxn],b[maxn],c[maxn];
long long dp[maxn];
int step[maxn];
int ans[maxn][2];
int main()
{
    scanf("%s%s",a+1,b+1);
    int len1 = strlen(a+1);
    int len2 = strlen(b+1);
    for(int i=1;i<=len2;i++)
        dp[i]=1e9;
    for(int i=1;i<=len1;i++)
        c[i]=a[len1-i+1];
    for(int i=1;i<=len1;i++)
    {
        for(int j=1;j<=len2;j++)
        {
            if(a[i]==b[j])dp1[i][j]=dp1[i-1][j-1]+1;
            if(b[j]==c[i])dp2[i][j]=dp2[i-1][j-1]+1;
        }
    }
    for(int i=1;i<=len2;i++)
    {
        for(int j=1;j<=len1;j++)
        {
            if(dp1[j][i])
            {
                if(dp[i]>dp[i-dp1[j][i]]+1)
                {
                    dp[i]=dp[i-dp1[j][i]]+1;
                    step[i]=i-dp1[j][i];
                }
            }
            if(dp2[j][i])
            {
                if(dp[i]>dp[i-dp2[j][i]]+1)
                {
                    dp[i]=dp[i-dp2[j][i]]+1;
                    step[i]=i-dp2[j][i];
                }
            }
        }
    }
    if(dp[len2]==1e9)return puts("-1");
    printf("%d
",dp[len2]);
    int sum = dp[len2];
    int now = len2;
    while(sum--)
    {
        for(int i=1;i<=len1;i++)
        {
            if(dp1[i][now]==now-step[now])
            {
                ans[sum][0]=i-dp1[i][now]+1,ans[sum][1]=i;
                now = step[now];
                break;
            }
            if(dp2[i][now]==now-step[now])
            {
                ans[sum][0]=len1-i+dp2[i][now],ans[sum][1]=len1-i+1;
                now = step[now];
                break;
            }
        }
    }
    for(int i=0;i<dp[len2];i++)
        printf("%d %d
",ans[i][0],ans[i][1]);
}